//----------------------------------------------------------------------------------
//  AUO_MT class
//----------------------------------------------------------------------------------
#include "output.h"
#include <vector>
#include <string>

struct AUO_PLUGIN {
	std::string filename;
	HMODULE module;
	OUTPUT_PLUGIN_TABLE *ptbl;
};

 struct AUO_MT_CONF_DATA {
	int magic;
	int n_buffer;
	int data_size;
	TCHAR plugin_name[256];
	BYTE data[];
};

enum AUO_REQUEST {
	REQ_NONE = 0,
	REQ_GET_AUDIO,
	REQ_GET_FLAG,
	REQ_GET_VIDEO_EX,
	REQ_EXIT
};

class AUO_MT {
	OUTPUT_INFO*			pinfo_orig;	//ʂnꂽIWi
	OUTPUT_INFO				oinfo;		//evOCɓn
	OUTPUT_PLUGIN_TABLE*	ptbl;		//
	AUO_MT_CONF_DATA*		conf_data;	//ݒf[^

	std::vector<AUO_PLUGIN>	plugin_list; //So̓vOC̃Xg

	//o̓Xbh
	HANDLE thread;
	unsigned int thread_id;
	volatile AUO_REQUEST req;	//o̓Xbh̗v

	volatile DWORD img_format;		//摜ǂݍ݃tH[}bg
	int buf_num;			//obt@
	size_t img_data_offs;	//1ʕ̃obt@ItZbg
	size_t img_data_size;	//1ʕ̃obt@TCY
	BYTE *img_data;			//摜obt@
	volatile int *img_data_n;		//obt@ɓĂt[ԍ
	volatile int img_data_cur;		//ǂݓ̊_
	volatile int *img_flag;			//t[̃tÕLbV
	volatile int *img_flag_n;		//Ήt[ԍ
	volatile int img_flag_cur;		//ǂݓ̊_

	//
	CRITICAL_SECTION cs_func;	//ubN֐یp
	HANDLE block_event;			//ꕔ̃ubN֐Ɏgp
	HANDLE slp_event;			//邱Ƃꍇɗp

	//for get_img,get_flag
	volatile int get_img_frame;
	volatile DWORD get_img_fmt;

	//for get_flag
	volatile int get_flag_frame;

	//for get_audio(sync)
	int get_audio_start;
	int get_audio_length;
	int *get_audio_read;
	void *get_audio_ret;

	//񓯊ɏAPIp
	volatile BOOL req_abort;
	volatile bool req_abort_chk;
	volatile bool req_update_prv;
	volatile int  rest_disp_now;
	volatile int  rest_disp_total;
	volatile int  rest_disp_now_old;
	volatile int  rest_disp_total_old;

public:
	AUO_MT(void);
	~AUO_MT(void);

	bool init(void);
	void init_param0(void);
	//void exit(void) { if(ptbl) ptbl->func_exit(); }

	int get_buff_num(void) const { return buf_num; };
	void set_buff_num(int n) { buf_num = n; };
	OUTPUT_PLUGIN_TABLE* get_cur_ptbl(void) const { return ptbl; };
	void set_cur_ptbl(OUTPUT_PLUGIN_TABLE* p) { ptbl = p; };
	std::vector<AUO_PLUGIN>* get_plugin_list(void) { return &plugin_list; };

	int config_get(void *data, int size);
	int config_set(void *data, int size);

	//for func_output()
	bool init_output(OUTPUT_INFO *oip);
	bool start_thread(void);
	BOOL wait_thread(void);
	bool output_start(void);

private:
	//cached data
	void *get_video_cached(int frame, DWORD format);
	int get_flag_cached(int frame);

	int find_output_pulgin(std::vector<AUO_PLUGIN> &list);
	int get_output_pulgin_tbl(std::vector<AUO_PLUGIN> &list);
	int load_output_pulgin(std::vector<AUO_PLUGIN> &list);
	AUO_PLUGIN* search_output_pulgin(std::vector<AUO_PLUGIN> &list, const std::string &name);
	AUO_PLUGIN* search_output_pulgin(std::vector<AUO_PLUGIN> &list, const OUTPUT_PLUGIN_TABLE *ptbl);
	void show_message_box(const TCHAR *msg);

	//proc functions in output_start(void)
	bool read_ahead_video(const int &prv, const int &nxt);
	bool read_ahead_flag(const int &prv, const int &nxt);
	void req_audio_proc(void);
	void req_flag_proc(void);
	void req_video_proc(void);
	void async_func_proc(void);
	bool on_format_change(void);
	
	//AviUtl output API
	friend void* __cdecl func_get_video_mt(int frame);
	friend void* __cdecl func_get_audio_mt(int start, int length, int *readed);
	friend BOOL  __cdecl func_is_abort_mt(void);
	friend BOOL  __cdecl func_rest_time_disp_mt(int now, int total);
	friend int   __cdecl func_get_flag_mt(int frame);
	friend BOOL  __cdecl func_update_preview_mt(void);
	friend void* __cdecl func_get_video_ex_mt(int frame, DWORD format);

	//thread func
	friend unsigned int __stdcall th_output(void *ptr);
};

//AUO_MTIuWFNg
extern AUO_MT* g_pAMT;
extern OUTPUT_PLUGIN_TABLE output_plugin_table;

#define N_BUFF_DEF 8 

