//---------------------------------------------------------------------
//	ݒ_CAO
//---------------------------------------------------------------------
#include <windows.h>

#include <commctrl.h>

#include "auo_mt.h"
#include "resource.h"

#define N_BUFF_MAX 48

//֐
static void init_dlg(HWND hdlg, LPARAM lparam);
static void check_dlg(HWND hdlg);
bool show_config_dlg(HWND hdlg, bool test);
static void notify_list(HWND hdlg, WPARAM wparam);

LRESULT CALLBACK func_config_proc(HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam)
{
	switch( umsg ) {
		case WM_INITDIALOG:
			init_dlg(hdlg, lparam);
			return TRUE;
		case WM_COMMAND:
			switch( LOWORD(wparam) ) {
				case IDC_CONFING:
					show_config_dlg(hdlg, false);
					break;
				case IDC_PULGIN_LIST:
					notify_list(hdlg, wparam);
					break;
				case IDCANCEL:
					EndDialog(hdlg, LOWORD(wparam));
					break;
				case IDOK:
					check_dlg(hdlg);
					EndDialog(hdlg, LOWORD(wparam));
					break;
			}
			break;
	}
	return FALSE;
}

//_CAȌ
void init_dlg(HWND hdlg, LPARAM lparam)
{
	AUO_MT *pAMT = reinterpret_cast<AUO_MT*>(lparam);
	SetWindowLongPtr(hdlg, DWLP_USER, lparam);

	//ǂ݃obt@
	SetDlgItemInt(hdlg, IDC_BUFFNUM, pAMT->get_buff_num(), FALSE);
	SendDlgItemMessage(hdlg, IDC_BUFFNUM_SPIN, UDM_SETRANGE32, 1, N_BUFF_MAX);

	//Xg
	std::vector<AUO_PLUGIN> *plist = pAMT->get_plugin_list();
	for(unsigned int i=0; i<plist->size(); ++i){
		std::string str((*plist)[i].ptbl->name);
		str.append(" (");
		str.append((*plist)[i].filename);
		str.push_back(')');

		SendDlgItemMessage(hdlg, IDC_PULGIN_LIST, LB_ADDSTRING, 0, (LPARAM)str.c_str());
		SendDlgItemMessage(hdlg, IDC_PULGIN_LIST, LB_SETITEMDATA, i, (LPARAM)i);

		//I
		if((i == 0) || ((*plist)[i].ptbl == pAMT->get_cur_ptbl())){
			SendDlgItemMessage(hdlg, IDC_PULGIN_LIST, LB_SETCURSEL, i, 0);
			if((*plist)[i].ptbl->func_config){
				EnableWindow(GetDlgItem(hdlg, IDC_CONFING), TRUE);
				SetWindowText(GetDlgItem(hdlg, IDC_PULGIN_INFO),
					(*plist)[i].ptbl->information);
			}else{
				EnableWindow(GetDlgItem(hdlg, IDC_CONFING), FALSE);
			}
		}
	}

}

//_CAOݒ̎擾
void check_dlg(HWND hdlg)
{	
	AUO_MT *pAMT = reinterpret_cast<AUO_MT*>(GetWindowLongPtr(hdlg, DWLP_USER));
	if(NULL == pAMT) return;

	//ǂ݃obt@
	BOOL t;
	UINT n = GetDlgItemInt(hdlg, IDC_BUFFNUM, &t, FALSE);
	if(t && n>0 && n<=N_BUFF_MAX){
		pAMT->set_buff_num(n);
	}else{
		pAMT->set_buff_num(N_BUFF_DEF);
	}

	//Xg
	LRESULT sel;
	std::vector<AUO_PLUGIN> *plist = pAMT->get_plugin_list();
	sel = SendDlgItemMessage(hdlg, IDC_PULGIN_LIST, LB_GETCURSEL, 0, 0);
	if(sel == LB_ERR){
		pAMT->set_cur_ptbl(NULL);
	}else{
		sel = SendDlgItemMessage(hdlg, IDC_PULGIN_LIST, LB_GETITEMDATA, sel, 0);
		if(sel == LB_ERR){
			pAMT->set_cur_ptbl(NULL);
		}else{
			pAMT->set_cur_ptbl((*plist)[sel].ptbl);
		}
	}
}

//o̓vOC̐ݒ\
bool show_config_dlg(HWND hdlg, bool test)
{	
	AUO_MT *pAMT = reinterpret_cast<AUO_MT*>(GetWindowLongPtr(hdlg, DWLP_USER));
	if(NULL == pAMT) return false;

	//Xg
	LRESULT sel;
	AUO_PLUGIN *pplg;
	std::vector<AUO_PLUGIN> *plist = pAMT->get_plugin_list();
	sel = SendDlgItemMessage(hdlg, IDC_PULGIN_LIST, LB_GETCURSEL, 0, 0);
	if(sel == LB_ERR){
		; /* Ȃ */
	}else{
		sel = SendDlgItemMessage(hdlg, IDC_PULGIN_LIST, LB_GETITEMDATA, sel, 0);
		if(sel != LB_ERR){
			SetWindowText(GetDlgItem(hdlg, IDC_PULGIN_INFO),
					(*plist)[sel].ptbl->information);
			pplg = &(*plist)[sel];
			if(pplg->ptbl->func_config){
				if(!test){
					pplg->ptbl->func_config(hdlg, pplg->module);
				}
				return true;
			}
		}
	}

	return false;
}

//I󋵂ɂ\ύX
static void notify_list(HWND hdlg, WPARAM wparam)
{
	switch(HIWORD(wparam)){
		case LBN_SELCHANGE:
			if(show_config_dlg(hdlg, true)){
				EnableWindow(GetDlgItem(hdlg, IDC_CONFING), TRUE);
			}else{
				EnableWindow(GetDlgItem(hdlg, IDC_CONFING), FALSE);
			}
			break;
	}
}
