//----------------------------------------------------------------------------------
//  output plugin T
//----------------------------------------------------------------------------------
#include <windows.h>
#include <strsafe.h>
#include <shlwapi.h>

#include "auo_mt.h"

#ifndef ARRAYSIZE
#define ARRAYSIZE(a)  (sizeof(a)/sizeof((a)[0]))
#endif
#define MAGIC ('mki')

typedef	OUTPUT_PLUGIN_TABLE* (__stdcall * GetOutpTbl)(void);

//RXgN^
AUO_MT::AUO_MT()
{
	//ȍ
	pinfo_orig = NULL;
	memset(&oinfo, 0, sizeof(oinfo));
	ptbl = NULL;
	conf_data = NULL;

	thread = 0;
	thread_id = 0;
	slp_event = block_event = 0;

	init_param0();

	buf_num = N_BUFF_DEF;
	img_data_offs = img_data_size = 0;

	//I蓖Čn
	conf_data = NULL;
	img_data_n = img_flag = img_flag_n = NULL;
	img_data = NULL;
}

//fXgN^
AUO_MT::~AUO_MT()
{
	//\[X̊J
	DeleteCriticalSection(&cs_func);
	CloseHandle(block_event);
	CloseHandle(slp_event);

	//CũA[h
	std::vector<AUO_PLUGIN>::iterator p = plugin_list.begin();
	while(p != plugin_list.end()){
		if(p->ptbl->func_exit) p->ptbl->func_exit();
		FreeLibrary(p->module);
		++p;
	}

	//J
	plugin_list.clear();
	free(conf_data);
	delete[] img_data_n;
	delete[] img_flag;
	delete[] img_flag_n;
	VirtualFree(img_data, 0, MEM_RELEASE);
}

//
bool AUO_MT::init(void)
{
	//\[Xm
	InitializeCriticalSection(&cs_func);
	block_event = CreateEvent(NULL, FALSE, FALSE, NULL);
	if(NULL == block_event){
		return false;
	}
	slp_event = CreateEvent(NULL, TRUE, FALSE, NULL); //蓮
	if(NULL == slp_event){
		return false;
	}

#if 0
	//Lȏo̓vOCXgAbv
	find_output_pulgin(plugin_list);
	get_output_pulgin_tbl(plugin_list);
#else
	load_output_pulgin(plugin_list);
#endif

	//vOCݒ
	if(plugin_list.size() > 0){
		ptbl = plugin_list.begin()->ptbl;
	}else{
		ptbl = NULL;
	}

	return true;
}

//ݒ
int AUO_MT::config_get(void *data, int size)
{
	//data == NULL ̏ꍇTCYԂƂH
	int ret = 0;
	bool do_get = false;

	//s`FbN
	if(ptbl){
		if(ptbl->func_config_get){
			do_get = true;
		}
	}

	if(do_get){ //vOCIς and ݒ֐
		if(data){
			if(!conf_data){
				//ݒf[^̈悪mۂĂȂi肦ȂHj
				return 0;
			}else if((sizeof(AUO_MT_CONF_DATA) + conf_data->data_size) > (DWORD)size){
				//^ꂽTCYȂi肦ȂHj
				return 0;
			}
			//ݒf[^𓾂	
			ret = ptbl->func_config_get(conf_data->data, conf_data->data_size);
			memcpy(data, conf_data, (sizeof(AUO_MT_CONF_DATA) + conf_data->data_size));
		}else{ //data == NULL
			ret = ptbl->func_config_get(NULL, size - sizeof(AUO_MT_CONF_DATA));
			//ݒf[^̊m
			size_t new_size = ret + sizeof(AUO_MT_CONF_DATA);
			free(conf_data);
			conf_data = static_cast<AUO_MT_CONF_DATA*>(malloc(new_size + 1024)); //܂
			if(!conf_data) return 0;

			//
			memset(conf_data, 0, new_size + 1024);
			conf_data->magic = MAGIC;
			conf_data->n_buffer = buf_num;
			conf_data->data_size = ret;

			AUO_PLUGIN *pplg = search_output_pulgin(plugin_list, ptbl);
			if(NULL == pplg) return 0;

			StringCchCopy(conf_data->plugin_name, 
				ARRAYSIZE(conf_data->plugin_name), pplg->filename.c_str());
		}
		ret += sizeof(AUO_MT_CONF_DATA);
	}else{ //vOCI or ݒ֐Ȃ
		if(data){
			AUO_MT_CONF_DATA *pcfg = static_cast<AUO_MT_CONF_DATA*>(data);

			memset(pcfg, 0, sizeof(AUO_MT_CONF_DATA));
			pcfg->magic = MAGIC;
			pcfg->n_buffer = buf_num;
			if(ptbl) {
				AUO_PLUGIN *pplg = search_output_pulgin(plugin_list, ptbl);
				if(NULL == pplg) return 0;

				StringCchCopy(pcfg->plugin_name, 
					ARRAYSIZE(pcfg->plugin_name), pplg->filename.c_str());
			}
		}
		ret = sizeof(AUO_MT_CONF_DATA);
	}

	return ret;
}

int AUO_MT::config_set(void *data, int size)
{
	AUO_MT_CONF_DATA *pconf = static_cast<AUO_MT_CONF_DATA*>(data);

	if(!data) return 0;

	//f[^̃`FbN
	if(pconf->magic != MAGIC){
		return 0;
	}

	//o̓vOC̃`FbN
	pconf->plugin_name[ARRAYSIZE(pconf->plugin_name) - 1] = TEXT('\0');
	std::string plg_name(pconf->plugin_name);
	AUO_PLUGIN *pplg = search_output_pulgin(plugin_list, plg_name);
	if(NULL == pplg){
		free(conf_data);
		conf_data = NULL;
		ptbl = NULL;
		return 0;
	}

	//ݒNAăRs[
	free(conf_data);
	conf_data = static_cast<AUO_MT_CONF_DATA*>(malloc(size));
	if(!conf_data) return 0;

	memcpy(conf_data, data, size);
	ptbl = pplg->ptbl;
	buf_num = conf_data->n_buffer;

	//ΏۃvOC̐ݒZbg
	int ret = 0;
	if(ptbl->func_config_set){
		ret = ptbl->func_config_set(conf_data->data, conf_data->data_size);
	}

	return ret + sizeof(AUO_MT_CONF_DATA);
}

//o̓vOC̐Ԃ
int AUO_MT::find_output_pulgin(std::vector<AUO_PLUGIN> &list)
{
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	AUO_PLUGIN aop;
	TCHAR cur_dir[MAX_PATH+1];
	TCHAR exe_dir[MAX_PATH+1];

	//XgNA
	list.clear();

	//JgfBNgꎞIɕύX
	if(0 == GetModuleFileName(NULL, exe_dir, MAX_PATH)){
		return 0;
	}
	if(0 == GetCurrentDirectory(MAX_PATH, cur_dir)){
		return 0;
	}
	PathRemoveFileSpec(exe_dir);
	if(!SetCurrentDirectory(exe_dir)){
		return 0;
	}

	//܂JgfBNg"*.auo"t@C
	hFind = FindFirstFile(TEXT("*.auo"), &FindFileData);
	if(hFind != INVALID_HANDLE_VALUE) {
		do{
			if(!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				aop.filename = FindFileData.cFileName;
				aop.module = 0;
				aop.ptbl = NULL;
				list.push_back(aop);
			}
		}while(FindNextFile(hFind, &FindFileData));
		FindClose(hFind);
	}

	//"Plugins"fBNg"*.auo"t@C
	hFind = FindFirstFile(TEXT("Plugins"), &FindFileData);
	if(hFind == INVALID_HANDLE_VALUE) {
		//"Plugins"fBNg݂Ȃꍇ͂ŕԂ
		SetCurrentDirectory(cur_dir);
		return list.size();
	}else{
		FindClose(hFind);
	}
    if(!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
		//"Plugins"fBNgŖꍇԂ
		SetCurrentDirectory(cur_dir);
		return list.size();
	}
	//"Plugins\*.auo"t@C
	hFind = FindFirstFile(TEXT("Plugins\\*.auo"), &FindFileData);
	if(hFind != INVALID_HANDLE_VALUE) {
		do{
			if(!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				aop.filename = FindFileData.cFileName;
				aop.module = 0;
				aop.ptbl = NULL;
				list.push_back(aop);
			}
		}while(FindNextFile(hFind, &FindFileData));
		FindClose(hFind);
	}

	//Ō"Plugins"fBNg̃TufBNg"*.auo"t@C
	hFind = FindFirstFile(TEXT("Plugins\\*"), &FindFileData);
	if(hFind != INVALID_HANDLE_VALUE) {
		WIN32_FIND_DATA FindFileData2;
		HANDLE hFind2;
		TCHAR buf[MAX_PATH];

		do{
			if((FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				&& (FindFileData.cFileName[0] != TEXT('.')))
			{
				//"Plugins\DIR\*.auo"t@C
				StringCchPrintf(buf, MAX_PATH, TEXT("Plugins\\%s\\*.auo"), FindFileData.cFileName);
				buf[ARRAYSIZE(buf)-1] = TEXT('\0');
				hFind2 = FindFirstFile(buf, &FindFileData2);
				if(hFind2 != INVALID_HANDLE_VALUE) {
					do{
						if(!(FindFileData2.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
							aop.filename = FindFileData2.cFileName;
							aop.module = 0;
							aop.ptbl = NULL;
							list.push_back(aop);
						}
					}while(FindNextFile(hFind2, &FindFileData2));
					FindClose(hFind2);
				}
			}
		}while(FindNextFile(hFind, &FindFileData));
		FindClose(hFind);
	}

	//JgfBNg𕜋A
	SetCurrentDirectory(cur_dir);
	return list.size();
}


//o̓vOC̃vOCe[u𓾂
int AUO_MT::get_output_pulgin_tbl(std::vector<AUO_PLUGIN> &list)
{
	HMODULE hModule;
	std::vector<AUO_PLUGIN>::iterator p = list.begin();
	GetOutpTbl get_tbl;

	while(p != list.end()){
		hModule = GetModuleHandle(p->filename.c_str());
		if(NULL == hModule){
			//Ώۂ"*.auo"ǂݍ܂ĂȂꍇ
			p = list.erase(p);
			continue;
		}

		//GetOutputPluginTable()𓾂
		get_tbl = (GetOutpTbl)GetProcAddress(hModule, "GetOutputPluginTable");
		if(NULL == get_tbl){
			//GetOutputPluginTable()Ȃꍇ
			p = list.erase(p);
			continue;
		}
		p->module = hModule;
		p->ptbl = get_tbl();

		if(0 == strcmp(p->ptbl->name, output_plugin_table.name)){
			//g͍폜
			p = list.erase(p);
			continue;
		}

		++p;
	}

	return list.size();
}

//o̓vOC[h
int AUO_MT::load_output_pulgin(std::vector<AUO_PLUGIN> &list)
{
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	AUO_PLUGIN aop;
	TCHAR cur_dir[MAX_PATH+1];
	TCHAR plg_dir[MAX_PATH+1];

	//XgNA
	list.clear();

	//JgfBNgꎞIɕύX
	if(0 == GetModuleFileName(NULL, plg_dir, MAX_PATH)){
		return 0;
	}
	if(0 == GetCurrentDirectory(MAX_PATH, cur_dir)){
		return 0;
	}
	PathRemoveFileSpec(plg_dir);
	StringCchCat(plg_dir, MAX_PATH, TEXT("\\auo_mt"));
	if(!SetCurrentDirectory(plg_dir)){
		//"auo_mt"fBNgɈړłȂ
		return 0;
	}
	
	// vOČ
	//"auo_mt"fBNg"*.auo_"t@C
	hFind = FindFirstFile(TEXT("*.auo_"), &FindFileData);
	if(hFind != INVALID_HANDLE_VALUE) {
		do{
			if(!(FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				aop.filename = FindFileData.cFileName;
				aop.module = 0;
				aop.ptbl = NULL;
				list.push_back(aop);
			}
		}while(FindNextFile(hFind, &FindFileData));
		FindClose(hFind);
	}

	// Cũ[h
	//
	HMODULE hModule;
	std::vector<AUO_PLUGIN>::iterator p = list.begin();
	GetOutpTbl get_tbl;

	while(p != list.end()){
		hModule = LoadLibrary(p->filename.c_str());
		if(NULL == hModule){
			//Ώۂ"*.auo_"ǂݍݎs
			p = list.erase(p);
			continue;
		}

		//GetOutputPluginTable()𓾂
		get_tbl = (GetOutpTbl)GetProcAddress(hModule, "GetOutputPluginTable");
		if(NULL == get_tbl){
			//GetOutputPluginTable()Ȃꍇ
			FreeLibrary(hModule);
			p = list.erase(p);
			continue;
		}
		p->module = hModule;
		p->ptbl = get_tbl();

		if(0 == strcmp(p->ptbl->name, output_plugin_table.name)){
			//g͍폜
			FreeLibrary(hModule);
			p = list.erase(p);
			continue;
		}

		if(p->ptbl->func_init){
			if(FALSE == p->ptbl->func_init()){
				//Ɏsꍇ폜
				FreeLibrary(hModule);
				p = list.erase(p);
				continue;
			}
		}
		++p;
	}

	//JgfBNg𕜋A
	SetCurrentDirectory(cur_dir);
	return list.size();
}

//vOCT[` by name
AUO_PLUGIN* AUO_MT::search_output_pulgin(std::vector<AUO_PLUGIN> &list, const std::string &name)
{
	std::vector<AUO_PLUGIN>::iterator p = list.begin();

	while(p != list.end()){
		if(p->filename == name){
			return &*p;
		}
		++p;
	}

	return NULL;
}

//vOCT[` by tbl
AUO_PLUGIN* AUO_MT::search_output_pulgin(std::vector<AUO_PLUGIN> &list, const OUTPUT_PLUGIN_TABLE *ptbl)
{
	std::vector<AUO_PLUGIN>::iterator p = list.begin();

	while(p != list.end()){
		if(p->ptbl == ptbl){
			return &*p;
		}
		++p;
	}

	return NULL;
}

//G[bZ[W̕\
void AUO_MT::show_message_box(const TCHAR *msg)
{
	MessageBox(NULL, msg, output_plugin_table.name, MB_ICONERROR|MB_SYSTEMMODAL);
}
